
/*******************************************************************************
 synch.addressbook.groupdav.js
 
 Copyright:	Inverse groupe conseil, 2006 
 Author: 		Robert Bolduc
 Email:		support@inverse.ca 
 URL:			http://inverse.ca
  
 This file is part of "Addressbook GroupDAV Connector" a Thunderbird extension.

    "Addressbook GroupDAV Connector" is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 2 as published by
    the Free Software Foundation;

    "Addressbook GroupDAV Connector" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with "Addressbook GroupDAV Connector"; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 
 * 
 ********************************************************************************/

// Making the asumption that the keys provided by the server are always unique
// so using simple  pseudo hash tables to store the information.
var serverVersionHash;	
var serverDataHash;      // stores vcards
var localVersionHash;    // stores the version no of the local cards
var localUpdateHash;     // stores keys (the value is set to true)
var localAdditionHash;  	// stores vcards 
var localDeleteHash = {};		// store keys
    localDeleteHash.size = 0;
var serverDeleteHash;		// store keys
var conflictHash;			// store keys of conflicts
var localCardPointerHash; //stores mozilla cards

var gURL;
var gUser;
var gPassword;
var gDisplaySyncDialog;

var gSelectedDirectoryURI; // gAddressBook to synchronize
var gAddressBook;
var gGroupDavServerInterface;

var gDownloadChannel= null;

var messengerWindow = Components.classes["@mozilla.org/appshell/window-mediator;1"]
																.getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("mail:3pane");

//var gObserverService is defined in addressbook.groupdav.vcard.observers.js

/*******************************************************************************
 * 
 * 
 ******************************************************************************/

// Global instance of SynchProgressMeter
//var gProgressMeter;
/*******************************************************************************
 * Download Observer
 * 
 * 
 ******************************************************************************/
var vCardsDownloadObserver = {
    // Components.interfaces.nsIObserver
    observe: function(object, topic, data){  
      try{ 
      		switch (topic){
			//==================================================================================================================================              	
		   		case SynchProgressMeter.CARD_DOWNLOADED:
			//==================================================================================================================================           	

			 	var key = data;
            var card =  importFromVcard(serverDataHash[key], key, serverVersionHash[key], gSelectedDirectoryURI);
            if (localCardPointerHash[key]){
            // Replace local card with server card
					 localCardPointerHash[key].copy(card);
  					 localCardPointerHash[key].editCardToDatabase(gSelectedDirectoryURI); 		            	         	
            }else{
            // add the server card
					GetDirectoryFromURI(gSelectedDirectoryURI).addCard(card);
            }            

            //TODO: do a propfind to make sure the version no. has not changed.
//            importFromVcard(serverDataHash[key], key, serverVersionHash[key], gSelectedDirectoryURI);
            logDebug("importFromVcard() completed for card: " + key);
        		break;     								
         }
      }catch (e){
      	   exceptionHandler(window,"vCardsDownloadObserver.observe()",e);
      }
    },
    
    // Components.interfaces.nsISupports
    QueryInterface : function(iid){
       if ( iid.equals(Components.interfaces.nsIObserver) || iid.equals(Components.interfaces.nsISupportsWeakReference)
            || iid.equals(Components.interfaces.nsISupports))
          return this;
       else
          alert(iid);
          throw Components.results.NS_NOINTERFACE;
    }
 }; 

/*******************************************************************************
 * Upload Observer
 * 
 * 
 ******************************************************************************/

function VcardDownloadListener(uri,  channel, vCardKey){      
   this.mURI = uri;
   this.mCountRead = 0;
   this.mChannel = channel;
   this.mKey = vCardKey;
}

VcardDownloadListener.prototype = {
   mURI : null,
   mVcard : "",
   mCountRead : null,
   mChannel : null,
   mBytes : Array(),
   mKey : 0,

   onStopRequest : function (aRequest, aContext, aStatusCode) {
      try{
			var httpChannel = this.mChannel.QueryInterface(Components.interfaces.nsIHttpChannel);
        	if ((  httpChannel && httpChannel.requestSucceeded) && 
        			Components.isSuccessCode(aStatusCode) && this.mCountRead > 0){
        // vcard download completed, put the card in serverDataHash and notify the ObserverService
				serverDataHash[this.mKey] = this.mVcard;
           	messengerWindow.gAbWinObserverService.notifyObservers(null, SynchProgressMeter.CARD_DOWNLOADED, this.mKey);
        }else{
				messengerWindow.gAbWinObserverService.notifyObservers(null, SynchProgressMeter.CARD_DOWNLOAD_FAILED, this.mKey);   
			}
      }catch(e){
         throw e;
      }
   },

   onDataAvailable : function (aRequest, aContext, aInputStream, aOffset, aCount) {
   //Accumulate the data from the server in mVcard
      try{
      var scrStream = Components.classes['@mozilla.org/scriptableinputstream;1'].createInstance(Components.interfaces.nsIScriptableInputStream);
      scrStream.init(aInputStream);
      this.mVcard+=scrStream.read(aCount);    
      this.mCountRead += aCount;
      }catch(e){
         throw e;
      }
   },

   QueryInterface: function (iid) {
     if (!iid.equals(Components.interfaces.nsISupports) &&
         !iid.equals(Components.interfaces.nsIInterfaceRequestor) &&
         !iid.equals(Components.interfaces.nsIRequestObserver) &&
         !iid.equals(Components.interfaces.nsIDocShellTreeItem) &&
         !iid.equals(Components.interfaces.nsIChannelEventSink) &&
         !iid.equals(Components.interfaces.nsIProgressEventSink) && // see
                                                                     // below
         !iid.equals(Components.interfaces.nsIStreamListener)) {
       throw Components.results.NS_ERROR_NO_INTERFACE;
     }
     return this;
   },

   getInterface: function (iid) {
     try {
       return this.QueryInterface(iid);
     } catch (e) {
        throw Components.results.NS_NOINTERFACE;
     }
   },

   onStartRequest : function (aRequest, aContext) {
   },


   onChannelRedirect : function (aOldChannel, aNewChannel, aFlags) {
   },

   // nsIProgressEventSink: the only reason we support
   // nsIProgressEventSink is to shut up a whole slew of xpconnect
   // warnings in debug builds. (see bug #253127)
   onProgress : function (aRequest, aContext, aProgress, aProgressMax) { },
   onStatus : function (aRequest, aContext, aStatus, aStatusArg) { }
}

/***********************************************************
 * 
 * Fills the Server, 
 * LocalUpdate 
 * and Conflict data structures 
 * 
 * for the synchronization
 * 
 ***********************************************************/ 
function fillServerHashes(){
   
   // Get the list of all the vcards and their version from the GroupDAV server
   // TODO replace this call with a new propfind that will be put inside of ca.inverse.webdav.js 
   // instead of using webdavAPI.js
   var propsList = new Array("<D:getetag/>");
   var responseObj=webdav_propfind(gURL, propsList, gUser, gPassword);
   
   switch(responseObj.status) {      
   case 207:   
      var serializer = new XMLSerializer();      
      logDebug("PROPFIND response:\n\n" + serializer.serializeToString(responseObj.response));

		var doc = responseObj.response;
		if (doc == null){
			throw "The Server response to propfind is malformed.";
		}
      var hrefList = gGroupDavServerInterface.getServerVcardHrefList(doc); 
      if (hrefList){
      		logDebug("=========Begin Server Cards List, url is: " + gURL);
      		logDebug("\t\t\t List size = " + hrefList.length);
			for (var i=0; i<hrefList.length; i++){			
		    // Fill the Server Versions Hash, 
				var key = gGroupDavServerInterface.getKey(hrefList[i], gURL);    
				var version = gGroupDavServerInterface.getVersion(hrefList[i]);
				logDebug("Server Card key = " + key + "\t\t\tversion = " + version);
				serverVersionHash[key] = version;        	
			}  
			logDebug("=========End Server Cards List");         
		}  
      break;
   default:
      throw "Error connecting to GroupDAV Server; response status: " + responseObj.status;
  }      
}

// Fill the Local Directory data structures for the synchronization
function fillLocalHashes(){
    var cards = gAddressBook.childCards;
    var hasCards = false;
    try{
       cards.first();
       hasCards = true;
    }catch (ex){}// nsIEnumerator doesn't seem to provide any clean way to test for existence of elements
   
    while(hasCards){        
      var card = cards.currentItem().QueryInterface(Components.interfaces.nsIAbCard);
      var key = card.custom3;      
      if (key != ""){
      		// Cards that exist locally and on the server
			// Later, the function compareVersions() will use this information to determine 
			// if the cards needs to be uploaded or if there is a conflict
         localCardPointerHash[key] = card;
         localVersionHash[key] = card.custom4; // version
      }else{
			// Generate the key and save the modified card locally.
			var cardKey = gGroupDavServerInterface.getNewCardKey();
			card["custom3"]= cardKey;
			card.editCardToDatabase(gSelectedDirectoryURI);
			localCardPointerHash[cardKey] = card;
				      		
	      	// New card to export to the server      		
         localAdditionHash[cardKey] = card2vcard(card);
         localAdditionHash.size++;
      }
      try{ cards.next(); } catch(ex2){ hasCards = false; }                   
   }
}

function upLoadLocalAdditions(){
	if (localAdditionHash.size > 0){		
		for( var key in localAdditionHash){
			if (key != "size"){
				webdavAddVcard(gURL + key , localAdditionHash[key] ,key, gUser, gPassword, 
									messengerWindow.gGroupDAVProgressMeter, messengerWindow.gAbWinObserverService);				
			}
		}	
	}
}

function initProgressMeter(){
	//Initialize SynchProgressMeter (see addressbook.groupdav.overlay.js for definition)
	messengerWindow.gGroupDAVProgressMeter.displayMsg = gDisplaySyncDialog;	
	messengerWindow.gGroupDAVProgressMeter.abWindow2	= Components.classes["@mozilla.org/appshell/window-mediator;1"].
					getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("mail:addressbook");
	
	if (serverDataHash.size + localUpdateHash.size + localAdditionHash.size == 0){
		messengerWindow.gAbWinObserverService.notifyObservers(null, SynchProgressMeter.NOTHING_TO_DO, null);	
	}else{
		messengerWindow.gGroupDAVProgressMeter.initDownload(serverDataHash.size);
		messengerWindow.gGroupDAVProgressMeter.initUpload( localCardPointerHash, gSelectedDirectoryURI, localUpdateHash.size, localAdditionHash.size);
		messengerWindow.gGroupDAVProgressMeter.setVCardsUpDateSize(localUpdateHash.size);	
		messengerWindow.gGroupDAVProgressMeter.setVCardsAddSize(localAdditionHash.size);
		messengerWindow.gGroupDAVProgressMeter.setVCardsUploadTotalSize(localUpdateHash.size + localAdditionHash.size);	
	}
}

function uploadCards(){
	if(localUpdateHash.size + localAdditionHash.size > 0){
		messengerWindow.gAbWinObserverService.notifyObservers(null, SynchProgressMeter.SERVER_UPLOAD_BEGINS, null);
		upLoadLocalAdditions();//asynchronuous
	   uploadLocalUpdates(); // asynchronuous			
	}
}

function uploadLocalUpdates(){
	if (localUpdateHash.size > 0){		
	   for( var key in localUpdateHash){
		   	if (key != "size"){
					webdavUpdateVcard(gURL + key , card2vcard(localCardPointerHash[key]), key, gUser, gPassword, 
										messengerWindow.gGroupDAVProgressMeter, messengerWindow.gAbWinObserverService);   		
		   	}	   		
	   }	
	}
}

function downloadVcards(){
	if (serverDataHash.size > 0){		
		messengerWindow.gAbWinObserverService.notifyObservers(null,SynchProgressMeter.SERVER_DOWNLOAD_BEGINS , null);
		for( var key in serverDataHash){
			if (key != "size"){
				downloadVcardAsynch(key);
			}
		}	
	}	
}

function compareVersions(){
   for( var key in serverVersionHash){
      var serverVersion = serverVersionHash[key];
      var localVersion = 0;
      if (typeof(localVersionHash[key]) != "undefined"){
         localVersion = localVersionHash[key];
      }
      if(localVersion == 0){
      // No Local version, the vcard has to be downloaded
         serverDataHash[key] = "";
         serverDataHash.size++;         
      }else{
         var localVersionPrefix = getModifiedLocalVersion(localVersion);
         if (localVersionPrefix !=null){
      		//There was a local update
	         if (localVersionPrefix != serverVersion){
	         // There is a conflict if the version numbers are different.
	         // Otherwise, the local version will be uploaded later
	            conflictHash[key] = true;
         			serverDataHash[key] = "";
		         serverDataHash.size++;       	            
	
	         }else{
	            localUpdateHash[key] = true;
	            localUpdateHash.size++;
	         }
         }else if (localVersion < serverVersion){
         // Server version is more recent           	
	         serverDataHash[key] = "";
	         serverDataHash.size++;	                  
         }
      }
   }
}

function addObservers_Synch(){
	messengerWindow.gAbWinObserverService.addObserver(vCardsDownloadObserver, 	SynchProgressMeter.CARD_DOWNLOADED, true);	
}
function removeObservers_Synch(){
	messengerWindow.gAbWinObserverService.removeObserver(vCardsDownloadObserver, SynchProgressMeter.CARD_DOWNLOADED);	
}

function processDeletes(){
//TODO	
}

function processConflicts(){
   for( var key in conflictHash){
		importFromVcard(serverDataHash[key], key, serverVersionHash[key], gSelectedDirectoryURI);
		gAddressBook.dropCard(localCardPointerHash[key],false);
   }	
  logWarn("TODO:  Currently, conflicts are simply overwritten by the server version!");
}

// Downloads asynchronously a vcard from the GroupDAV server and stores it in
// serverDataHash
function downloadVcardAsynch(key){
	var fileUrl = gURL + key;
   var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
   var chan = ios.newChannel(fileUrl, null, null);
   
	logDebug("downloadVcardAsynch() url = " + fileUrl);
   var listener = new VcardDownloadListener (fileUrl, chan, key);
   chan.notificationCallbacks = listener;
   chan.asyncOpen(listener, null);
}

function initSynchVariables(){
		
	// Store the gAddressBook that was selected when Synchronize was clicked
	gSelectedDirectoryURI = GetSelectedDirectory();
	gAddressBook = GetDirectoryFromURI(gSelectedDirectoryURI);	
	gSynchIsRunning = true;
	
	try{//TODO: There has to be a cleaner way than that!!!
	   removeObservers_Synch();
	}catch(ex){}
					
	var groupdavPrefService = new GroupdavPreferenceService(gAddressBook.dirPrefId);
	gURL = groupdavPrefService.getURL();
	gUser = groupdavPrefService.getUser();
	gDisplaySyncDialog = groupdavPrefService.getDisplayDialog() == "true";
	gGroupDavServerInterface = GroupdavServerFactory.get(groupdavTypes.GroupDAV_Generic);
	
	gPassword = getPassword(groupdavPrefService.getHostName(), groupdavPrefService.getUser());
	logDebug("function initSynchVariables()\n\t\t\turl:[" + gURL + "] \n\t\t\thost:[" + groupdavPrefService.getHostName() +"]");
   addObservers_Synch();

   serverVersionHash = {};
   serverDataHash = {};
   serverDataHash.size = 0;
   localVersionHash = {};
   localCardPointerHash = {};
   localUpdateHash = {};
   localUpdateHash.size = 0;
   localAdditionHash = {};
   localAdditionHash.size = 0;
   conflictHash = {};
	localDeleteHash = {};
	localDeleteHash.size = 0;
	serverDeleteHash = {};
	serverDeleteHash.size = 0;
   
   
   //Initialization is completed
   messengerWindow.gAbWinObserverService.notifyObservers(null, SynchProgressMeter.INITIALIZATION_EVENT, null);	
}

/******************************************************************
 *  MENU functions
 ******************************************************************/
function SynchronizeGroupdavAddressbook(){	
   try{        
      initSynchVariables();
      fillServerHashes();
      fillLocalHashes();
		compareVersions();//Has to be done first it modifies Local Hashes		
      initProgressMeter();
      downloadVcards(); //asynchronuous
      uploadCards(); //asynchronous
      processConflicts();      
    }catch (e){
    	gSynchIsRunning = false; 
      exceptionHandler(window,"SynchronizeGroupdavAddressbook",e);
   }
}
