/*************************************************************************************************************   
Copyright:	Inverse groupe conseil, 2006 
   Author: 		Robert Bolduc
   Email:		support@inverse.ca 
   URL:			http://inverse.ca
   
   This file is part of "Addressbook GroupDAV Connector" a Thunderbird extension.

   "Addressbook GroupDAV Connector" is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as published by
   the Free Software Foundation;

"Addressbook GroupDAV Connector" is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with "Addressbook GroupDAV Connector"; if not, write to the Free Software
      Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 ********************************************************************************/
var connected = false; 


function getMessengerWindow(){

   return Components.classes["@mozilla.org/appshell/window-mediator;1"]
      .getService(Components.interfaces.nsIWindowMediator).getMostRecentWindow("mail:3pane");
}

function isWebdavConnectionUp(abURI){
   try{	
      if (abURI == null || abURI == ""){
         return false;
      }
      connected = false;
         var uri = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService)
         .GetResource(abURI).QueryInterface(Components.interfaces.nsIAbDirectory);
      
      var groupdavPrefService = new GroupdavPreferenceService(uri.dirPrefId);
      
      var url = groupdavPrefService.getHostName();
      var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
      var chan = ios.newChannel(url, null, null);
      
      var listener ={
         onStopRequest : function (aRequest, aContext, aStatusCode) {
            connected = true;
         },
         getInterface: function (iid) {
            try {
               return this.QueryInterface(iid);
            } catch (e) {
               throw Components.results.NS_NOINTERFACE;
            }
         },	   
         QueryInterface: function (iid) {
            if (!iid.equals(Components.interfaces.nsISupports) &&
                !iid.equals(Components.interfaces.nsIInterfaceRequestor) &&
                !iid.equals(Components.interfaces.nsIRequestObserver) &&
                !iid.equals(Components.interfaces.nsIDocShellTreeItem) &&
                !iid.equals(Components.interfaces.nsIChannelEventSink) &&
                !iid.equals(Components.interfaces.nsIProgressEventSink) && // see
                // below
                !iid.equals(Components.interfaces.nsIStreamListener)) {
                   throw Components.results.NS_ERROR_NO_INTERFACE;
                }
            return this;
         },
         onStartRequest : function (aRequest, aContext) {},	   
         onDataAvailable : function (aRequest, aContext, aInputStream, aOffset, aCount) {},
         onProgress : function (aRequest, aContext, aProgress, aProgressMax) { },
         onStatus : function (aRequest, aContext, aStatus, aStatusArg) { }	   		
      };
      chan.notificationCallbacks = listener;
      chan.asyncOpen(listener, null);
      var value = window.setTimeout("bidon()", 10000);
      return connected;
   }catch (e){
      getMessengerWindow().exceptionHandler(null,"Exception in isWebdavConnectionUp()",e);		
   }

  return false;   
}

//Use with timeout
isWebdavConnectionUp.Result= function(result){
   result = connected; 
}

function webdavAddVcard(webdavURL ,dataString, key, username, password, observerObj, observerService) {
   webdavPutString(webdavURL ,dataString, key, "text/x-vcard" ,username, password, observerObj, observerService, true);	
}

function webdavUpdateVcard(webdavURL ,dataString, key,username, password, observerObj, observerService) {
   webdavPutString(webdavURL ,dataString, key, "text/x-vcard" ,username, password, observerObj, observerService, false);
}

function webdavPutString(webdavURL ,dataString, key, contentType ,username, password, observerObj, observerService, isNew) {

   var uploadListener = {		   
      onDataAvailable: function (channel, ctxt, inStr, sourceOffset, count) {
         return;
      },
      onStartRequest: function (channel, ctxt) {
         return; 
      },
      onStopRequest: function (channel, ctxt, status) {
         var state = "";	
         try{			
         	var httpChannel = channel.QueryInterface(this.components.interfaces.nsIHttpChannel);
            if (this.components.results.NS_ERROR_NOT_AVAILABLE == status){
            	logWarn("Upload failure:\n\n" +NS_ERROR_NOT_AVAILABLE + "("+  status +")");
               state = "<state><status>" + "No Connection to server!  " +  status +"</status><url>" + webdavURL + "</url><context>" + ctxt + "</context></state>";    	 
               observerService.notifyObservers(window, SynchProgressMeter.UPLOAD_ERROR_EVENT, state);
               return;
            }else if(httpChannel.responseStatus != 201){
            	logWarn("Upload failure, Reponse is different than 201:\n\n"  + "Response Code:"+ httpChannel.responseStatus );
               if(observerService!=null){
                  state = "<state><status>" + httpChannel.responseStatus + "</status><url>" + webdavURL + "</url></state>";
                  observerService.notifyObservers(window, SynchProgressMeter.UPLOAD_ERROR_EVENT, state);
                  return;
               }
            }else{
               if(observerService!=null){
                  state = "<state><newCard>" + isNew + "</newCard><etag>" + httpChannel.getResponseHeader("etag") + 
                     "</etag><key>" + key + "</key></state>";
                  observerService.notifyObservers(window, SynchProgressMeter.UPLOAD_STOP_REQUEST_EVENT, state);
                  return; 
               }		     
            }
         } catch (e) {
				state = "<state><status>" + e + "\n File: "+  e.fileName + "\n Line: " + e.lineNumber + "\n\n Stack:\n\n" + e.stack+ "</status>" +
									"<url>" + webdavURL + "</url></state>";
            observerService.notifyObservers(window, SynchProgressMeter.UPLOAD_ERROR_EVENT, state);		   	
         }
      }
   };
   uploadListener.components = Components; // To get a handle on Components inside the listener!!!
      
   try{
      var stream=Components.classes['@mozilla.org/io/string-input-stream;1'].createInstance(Components.interfaces.nsIStringInputStream);
      stream.setData (dataString, dataString.length);
      
      var webURL = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURL);
      webURL.spec = webdavURL;
      
      if(username!=null && username!="" && password!=null && password!="") {
         webURL.username=username;
         webURL.password=password;
      }
      var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
      var channel = ios.newChannelFromURI(webURL).QueryInterface(Components.interfaces.nsIHttpChannel);
      channel.referrer=webURL;
      channel.requestMethod="PUT";
      
      var uploadChannel = channel.QueryInterface(Components.interfaces.nsIUploadChannel);
      uploadChannel.setUploadStream(stream, contentType, dataString.length );
      logDebug("Sending card: " + key + "\n" +  dataString);
      uploadChannel.asyncOpen(uploadListener, null);
   } catch (e) {
      //error handling
      if(observerObj!=null){ 
         observerService.notifyObservers(window,observerObj.onErrorEventName,e);
      }
      getMessengerWindow().exceptionHandler(null,"webdavPutString.uploadListener.onStopRequest",e);	
   }
}

